/* 
Create by Sam Su,
本模板由苏老师(Sam Su)开发.
 2020.02.23
 */
// 基本服务搭建
var express=require('express');
var bd=require('body-parser')
var app=express();
app.listen(3000);

// 安装 express 模块   npm i express
// ========================================
// 静态  前端 文件  处理
app.use('/',express.static('qian'))
// ========================================
app.use(bd.urlencoded({extended:false}))
// ========================================
// view engine setup
app.set('view engine', 'ejs');
// ========================================
// json示例
var json={
	title:"列表模块",
	list:[
		{"img":"img/a.png","txt":"图片说明"},
		{"img":"img/b.png","txt":"介绍图片"},
		{"img":"img/c.png","txt":"说明文字"}
	]
}
// ========================================

// 路由
app.get('/get',function(请求,响应){
	// 请求里的query对象是前端的参数集合
	console.log(请求.query)
	响应.send('get路由 测试成功')
})

// 路由 输出 json
app.get('/ajax',function(请求,响应){
	// 请求里的query对象是前端的参数集合
	响应.send(json);
})

//ejs 模板

const ejs = require('ejs');
// 要展示到页面中数据
const colors = ['red', 'green', 'blue'];

// 使用 EJS 语法编写的模板
const template = `
    <ul>

        <% colors.forEach((value, index) => { %>
            <li><%= value %></li>
        <% }) %>
    </ul>
`



app.get('/ejs',function(req,res){
	var tem=`
	<h1><%=2+3%></h1>
	<hr>
	<%for(var i=0;i<100;i++){%>
		<%=i%>
	<%}%>
	<hr>
	
	<%if(3>5){%>
		<%='分支1'%>
	<%}else{%>
		<%="分支两"%>
	<%}%>
	
	<h1><%=title%></h1>
	<%for(var i=0;i<list.length;i++){%>
		<span><%=list[i].txt%></span>
	<%}%>
	`
	// HTML代码 = EJS模板 + 数据
	const html = ejs.render(tem,json);
	res.send(html);
})

app.get('/ejs-html', function(req, res){
    res.render('ejs-html.ejs',json);
});


// post路由
app.post('/post',function(请求,响应){
	// 请求里的query对象是前端的参数集合
	console.log(请求.query)
	响应.send('post路由 测试成功')
})

module.exports=app;